void dt(
	unsigned char *,
	short *,
	short *,
	short *,
	int,
	int,
	int,
	int,
	unsigned char * ) ;
void dc(unsigned char *, short *, int, int, int, unsigned char *) ;
short gk(unsigned char *, unsigned short) ;
int gb(unsigned char *) ;

static unsigned long UL0= 16 ;
static unsigned long UL1,UL2,UL3,UL4,ULM ;

static unsigned char bm,bc ;
static int cn,cm ;
static unsigned long vl,lo,hi ;

static int hbx[256]= {
	 0, 1, 1, 0,  0, 0, 1, 1,  2, 2, 3, 3,  3, 2, 2, 3,
	 4, 4, 5, 5,  6, 7, 7, 6,  6, 7, 7, 6,  5, 5, 4, 4,
	 4, 4, 5, 5,  6, 7, 7, 6,  6, 7, 7, 6,  5, 5, 4, 4,
	 3, 2, 2, 3,  3, 3, 2, 2,  1, 1, 0, 0,  0, 1, 1, 0,

	 0, 0, 1, 1,  2, 3, 3, 2,  2, 3, 3, 2,  1, 1, 0, 0,
	 0, 1, 1, 0,  0, 0, 1, 1,  2, 2, 3, 3,  3, 2, 2, 3,
	 4, 5, 5, 4,  4, 4, 5, 5,  6, 6, 7, 7,  7, 6, 6, 7,
	 7, 7, 6, 6,  5, 4, 4, 5,  5, 4, 4, 5,  6, 6, 7, 7,

	 8, 8, 9, 9, 10,11,11,10, 10,11,11,10,  9, 9, 8, 8,
	 8, 9, 9, 8,  8, 8, 9, 9, 10,10,11,11, 11,10,10,11,
	12,13,13,12, 12,12,13,13, 14,14,15,15, 15,14,14,15,
	15,15,14,14, 13,12,12,13, 13,12,12,13, 14,14,15,15,

	15,14,14,15, 15,15,14,14, 13,13,12,12, 12,13,13,12,
	11,11,10,10,  9, 8, 8, 9,  9, 8, 8, 9, 10,10,11,11,
	11,11,10,10,  9, 8, 8, 9,  9, 8, 8, 9, 10,10,11,11,
	12,13,13,12, 12,12,13,13, 14,14,15,15, 15,14,14,15,
} ;

static int hby[256]= {
	 0, 0, 1, 1,  2, 3, 3, 2,  2, 3, 3, 2,  1, 1, 0, 0,
	 0, 1, 1, 0,  0, 0, 1, 1,  2, 2, 3, 3,  3, 2, 2, 3,
	 4, 5, 5, 4,  4, 4, 5, 5,  6, 6, 7, 7,  7, 6, 6, 7,
	 7, 7, 6, 6,  5, 4, 4, 5,  5, 4, 4, 5,  6, 6, 7, 7,

	 8, 9, 9, 8,  8, 8, 9, 9, 10,10,11,11, 11,10,10,11,
	12,12,13,13, 14,15,15,14, 14,15,15,14, 13,13,12,12,
	12,12,13,13, 14,15,15,14, 14,15,15,14, 13,13,12,12,
	11,10,10,11, 11,11,10,10,  9, 9, 8, 8,  8, 9, 9, 8,

	 8, 9, 9, 8,  8, 8, 9, 9, 10,10,11,11, 11,10,10,11,
	12,12,13,13, 14,15,15,14, 14,15,15,14, 13,13,12,12,
	12,12,13,13, 14,15,15,14, 14,15,15,14, 13,13,12,12,
	11,10,10,11, 11,11,10,10,  9, 9, 8, 8,  8, 9, 9, 8,

	 7, 7, 6, 6,  5, 4, 4, 5,  5, 4, 4, 5,  6, 6, 7, 7,
	 7, 6, 6, 7,  7, 7, 6, 6,  5, 5, 4, 4,  4, 5, 5, 4,
	 3, 2, 2, 3,  3, 3, 2, 2,  1, 1, 0, 0,  0, 1, 1, 0,
	 0, 0, 1, 1,  2, 3, 3, 2,  2, 3, 3, 2,  1, 1, 0, 0,
} ;

void rc(
	unsigned char *c0,
	short *d0,
	short *d1,
	short *d2,
	int *xs,
	int *ys,
	int lr,
	unsigned char *pp )
{
	int i,ii,st,n ;

	UL1=1 ; UL1<<= (UL0-2) ; UL2=UL1*2 ; UL3=UL1*3 ; UL4=UL1*4 ; ULM=UL4-1 ;

	st= xs[0] ; cn= 0 ; n= 0 ;
	for(i=lr;i>0;i--){
		ii= (lr-i)*36 ;
		dt(c0,d0,d1,d2,xs[i]         ,xs[i-1]-xs[i],        ys[i],st,pp+ii+ 0) ;
		dt(c0,d0,d1,d2,     +ys[i]*st,        xs[i],ys[i-1]-ys[i],st,pp+ii+12) ;
		dt(c0,d0,d1,d2,xs[i]+ys[i]*st,xs[i-1]-xs[i],ys[i-1]-ys[i],st,pp+ii+24) ;
	}
}

void dt(
	unsigned char *c0,
	short *d0,
	short *d1,
	short *d2,
	int og,
	int xs,
	int ys,
	int st,
	unsigned char *pp )
{
	dc(c0,d0+og,xs,ys,st,pp+0) ;
	dc(c0,d1+og,xs,ys,st,pp+4) ;
	dc(c0,d2+og,xs,ys,st,pp+8) ;
}

void dc(unsigned char *c0, short *d0, int xs, int ys, int st, unsigned char *pp){
	int i,j,ii,n ;
	unsigned long ip,jp,k0,k1,k2 ;
	short s ;

	ip= (unsigned long)(*(pp+0)) ;
	if(!ip){
		for(j=0;j<ys;j++){
		for(i=0;i<xs;i++){
			*(d0+i+j*st)= 0 ;
		}}
		return ;
	}
	ip= ip*ip*ip*ip ;

	k1= (unsigned long)(*(pp+1)) ;
	k2= (unsigned long)(*(pp+2)) ;
	k0= (256-k1)*(256-k2) ;
	k0= (ip >> 16)*k0 + (((ip & 65535)*k0 + 32768) >> 16) ;
	k2= (256-k1)*k2 ;
	k1*= 256 ;

	n= cn ; cm= 0 ; bm= 1 ; bc= *(c0+cn) ;
	vl= 0 ; for(i=0;i<UL0;i++) vl= 2*vl + gb(c0) ;
	lo= 0 ; hi= ULM ;
	jp= 32768*65535 ; jp= (jp << 1)-ip ;
	jp= 1 + (jp+32768+(ip >> 1))/(65536+ip) ;
	if(jp>65534) jp=65534 ;
	for(j=0;j<ys;j+=16){
	for(i=0;i<xs;i+=16){
		for(ii=0;ii<256;ii++){
		if(i+hbx[ii] < xs && j+hby[ii] < ys){
			s= gk(c0,jp) ;
			*(d0+(i+hbx[ii])+(j+hby[ii])*st)= s ;

			if(s<0) s= -s ;
			ip= (ip >> 16)*k2 + (((ip & 65535)*k2 + 32768 ) >> 16) + k0 ;
			if(s) ip+= s*k1 ;
			if(ip==0) ip=1 ;
			jp= 32768*65535 ; jp= (jp << 1)-ip ;
			jp= 1 + (jp+32768+(ip >> 1))/(65536+ip) ;
			if(jp>65534) jp=65534 ;
		}}
	}}
	cn= n+(cm+UL0+1+7)/8 ;
}

short gk(unsigned char *c0, unsigned short p){
	int i ;
	unsigned long bd ;
	short s=0 ;

	while(1){
		bd= lo + (((hi-lo+1)*p+32768) >> 16) ;
		if(vl >= bd){	lo= bd ; s++ ; i=1 ;}
		else{		hi= bd-1 ; i=0 ;}

		while(1){
			if(hi < UL2 || lo >= UL2){}
			else if(lo >= UL1 && hi < UL3){
				vl -= UL1 ; lo -= UL1 ;  hi -= UL1 ;
			}else break ;

			lo <<= 1 ; if(lo >= UL4){ lo -= UL4 ; }
			hi <<= 1 ; if(hi >= UL4){ hi -= UL4 ; }
			hi++ ;
			vl <<= 1 ; if(vl >= UL4){ vl -= UL4 ; }
			if(bc & bm) vl++ ;

			if(bm!=128){ bm<<= 1 ; }else{ bm= 1 ; cn++ ; bc= *(c0+cn) ; }

			cm++ ;
		}

		if(!i) break ;
	}

	if(s){
		bd= lo + ((hi-lo+2) >> 1) ;
		if(vl >= bd){	lo= bd ; s= -s ; }
		else{		hi= bd-1 ; }

		while(1){
			if(hi < UL2 || lo >= UL2){}
			else if(lo >= UL1 && hi < UL3){
				vl -= UL1 ; lo -= UL1 ;  hi -= UL1 ;
			}else break ;

			lo <<= 1 ; if(lo >= UL4){ lo -= UL4 ; }
			hi <<= 1 ; if(hi >= UL4){ hi -= UL4 ; }
			hi++ ;
			vl <<= 1 ; if(vl >= UL4){ vl -= UL4 ; }
			if(bc & bm) vl++ ;

			if(bm!=128){ bm<<= 1 ; }else{ bm= 1 ; cn++ ; bc= *(c0+cn) ; }

			cm++ ;
		}
	}

	return s ;
}

int gb(unsigned char *c0){
	int b ;

	if(bc & bm){ b= 1 ; }else{ b= 0 ; }
	if(bm!=128){ bm<<= 1 ; }else{ bm= 1 ; cn++ ; bc= *(c0+cn) ; }

	return b ;
}