#include <stdio.h>

#include "hr.c"
#include "rc.c"
#include "mp.c"
#include "ds.c"
#include "fp.c"

void us() ;

int main(int argc,char **argv){
	int fn,i,j,ii,jj,ih ;
	int xy,xs[9],ys[9],n,n0,n1 ;
	int gr,lr,ln,gl[2] ;
	unsigned char c,c0,c1,c2,c3 ;
	unsigned char *ca ;
	unsigned char pp[8*3*3*4] ;
	int pn[1] ;
	char f0[256],f1[256] ;
	short *d0,*d1,*d2,*dh ;
	FILE *file0 ;

	if(argc==1){ us() ; return ; }
	printf("hpc decoder\n") ;

for(fn=1;fn<argc;fn++){
	strcpy(f0,argv[fn]) ;

	n= strlen(f0) ;
	for(i=0;i<n;i++) *(f0+i)= (char)(tolower((int)(*(f0+i)))) ;
	printf("\ninput  %s",f0) ;

	strcpy(f1,f0) ;
	n= strlen(f1) ;
	if(strcmp(f1+n-4,".hpc")==0) *(f1+n-4)=NULL ;
	strcat(f1,"+.bmp") ;

	file0= fopen(f0,"rb+") ;
	if(file0==NULL){ printf("\n    ERROR: %s: Can not open file\n",f0) ; goto fileend ; }

	ih= hr(gl,xs,ys,pn,pp,file0) ;
	gr= gl[0] ; lr= gl[1] ;
	xy= xs[0]*ys[0] ;
	d0= (short *)malloc(8*xy) ;
	if(d0==NULL){ printf("\n    ERROR: No memory\n") ; goto fileend ; }

	d1= d0+xy ; d2= d0+2*xy ; dh= d0+3*xy ; ca= (unsigned char *)(d0+3*xy) ;

	for(j=0;j<ys[lr];j++){
	for(i=0;i<xs[lr];i++){
		c0= fgetc(file0) ; c1= fgetc(file0) ; c2= fgetc(file0) ; c3= fgetc(file0) ;

		*(d0+i+j*xs[0])= ((short)c0      + (short)(c1&7)*256 -  512) * 16 ;
		*(d1+i+j*xs[0])= ((short)(c1>>3) + (short)(c2&63)*32 - 1024) * 16 ;
		*(d2+i+j*xs[0])= ((short)(c2>>6) + (short)(c3)*4     -  512) * 16 ;
	}}

	for(i=0;i<(*pn);i++){ *(ca+i)= fgetc(file0) ; }

	fclose(file0) ;

	rc(ca,d0,d1,d2,xs,ys,lr,pp) ;

	mp(d0,d1,d2,xs,ys,gr,lr,pp) ;

	ds(d0,d1,d2,dh,xs,ys,lr) ;

	file0= fopen(f1,"wb+") ;
	fp(d0,d1,d2,xs,ys,file0) ;

	fclose(file0) ;
	free(d0) ;

printf("\noutput %s",f1) ;
printf("
    width= %d, height= %d : grade= %d.%d
    %d bytes (%f bits / pixel)
",xs[0],ys[0],gr/64,gr%64,24+ih+4*xs[lr]*ys[lr]+(*pn),(float)(24+ih+4*xs[lr]*ys[lr]+(*pn))*8/xs[0]/ys[0]
) ;

fileend:
}

printf("\nCompleted\nhit Enter key to exit\n") ;

getchar() ;

}

void us(){

	printf("
hpc decoder

usage: dc [input file1] [input file2] ...

hit Enter key to exit
") ;

getchar() ;
}