#include "go.c"
#include "hd.c"
#include "rf.c"
#include "sb.c"
#include "qt.c"
#include "al.c"
#include "pb.c"
#include "of.c"

void cr(short *, short *, short *, unsigned char *, int, int, int) ;
void us() ;

int main(int argc,char **argv){
	unsigned long l ;
	int fn,i,j,ih,n ;
	long ix[1],iy[1] ;
	int xs[9],ys[9],xy ;
	unsigned char pp[8*3*3*4] ;
	int pn[1],n0,n1 ;
	short *d0,*bw,*vg,*br ;
	unsigned short *s0,*s1,*s2 ;
	unsigned char *c0,*c1 ;
	char f0[256],f1[256] ;
	FILE *file0,*file1 ;
	int lr,gr,lg ;

	if(argc==1){ us() ; return ; }
	printf("bmp compressor\n") ;

	go(*argv,pn) ; gr= *pn ;

for(fn=1;fn<argc;fn++){
	strcpy(f0,argv[fn]) ;

	n= strlen(f0) ;
	for(i=0;i<n;i++){
		f0[i]= (char)(tolower((int)(f0[i]))) ;
	}
	printf("\ninput  %s",f0) ;

	strcpy(f1,f0) ;
	n= strlen(f1) ;
	if(strcmp(f1+n-4,".bmp")==0) *(f1+n-4)=NULL ;
	strcat(f1,".hpc") ;

	file0= fopen(f0,"rb+") ;
	if(file0==NULL){
		printf("\n    ERROR: %s: Can not open file\n",f0) ;
		goto fileend ;
	}

	hd(file0,ix,iy) ;
	xs[0]= ix[0] ; ys[0]= iy[0] ;
	if(xs[0]==-1 || ys[0]==-1){
		printf("\n    ERROR: File Size too large\n") ;
		goto fileend ;
	}

	lr= 0 ; lg= gr ;
	for(i=0;i<8;i++){
		xs[i+1]= (xs[i]+1)/2 ;
		ys[i+1]= (ys[i]+1)/2 ;
		lg*= 2 ;
		if(xs[i]>11 && ys[i]>11 && lg<370728) lr= i+1 ;
	}
	xy= xs[0]*ys[0] ;

	c0= (unsigned char *)malloc(4*xs[lr]*ys[lr]) ;
	if(c0==NULL){
		printf("\n    ERROR: No memory\n") ;
		goto fileend ;
	}

	d0= (short *)malloc(8*xy) ;
	if(d0==NULL){
		printf("\n    ERROR: No memory\n") ;
		goto fileend ;
	}

	bw= d0 + xy ;
	vg= d0 + 2*xy ;
	br= d0 + 3*xy ;

	for(i=0;i<4*xy;i++) *(d0+i)=0 ;
	for(i=0;i<8*3*3*4;i++) *(pp+i)=0 ;

	rewind(file0) ;
	n= rf(file0,d0,bw,vg,br,xs[0],ys[0]) ;
	fclose(file0) ;
	if(n){
		printf("\n    ERROR: Not supported file format\n") ;
		free(c0) ; free(d0) ;
		goto fileend ;
	}

	sb(bw,d0,xs,ys,lr) ;
	sb(vg,d0,xs,ys,lr) ;
	sb(br,d0,xs,ys,lr) ;

	qt(bw,vg,br,xs,ys,gr,lr,pp) ;

	cr(bw,vg,br,c0,xs[lr],ys[lr],xs[0]) ;

	s0= (unsigned short *)d0 ; al(bw,s0,xs,ys,lr) ;
	s1= (unsigned short *)bw ; al(vg,s1,xs,ys,lr) ;
	s2= (unsigned short *)vg ; al(br,s2,xs,ys,lr) ;

	c1= (unsigned char *)br ;
	pb(s0,s1,s2,c1,xs,ys,lr,pn,pp) ;

	n0= 4*xs[lr]*ys[lr] ;
	n1= *pn ;

	file1= fopen(f1,"wb+") ;
	ih= of(c0,c1,xs,ys,gr,lr,pn,pp,file1) ;
	fclose(file1) ;

	free(c0) ; free(d0) ;

printf("\noutput %s",f1) ;
printf("
    width= %d, height= %d : grade= %d.%d
    %d bytes (%f bits / pixel)
",xs[0],ys[0],gr/64,gr%64,24+ih+n0+n1,(float)(24+ih+n0+n1)/(xs[0]*ys[0])*8) ;

fileend:
}

printf("\nCompleted\nhit Enter key to exit\n") ;

getchar() ;

}

void cr(short *bw, short *vg, short *br, unsigned char *c0, int xs, int ys, int st){
	int i,j,n ;
	short s ;
	unsigned short s0,s1,ss ;

	n= 0 ;
	for(j=0;j<ys;j++){
	for(i=0;i<xs;i++){
		s= *(bw+i+j*st)+512 ; if(s<0) s=0 ; if(s>2047) s=2047 ;
		ss= (unsigned short)s % 256 ;
		*(c0+n)= (unsigned char)ss ; n++ ;
		ss= (unsigned short)s / 256 ;

		s= *(vg+i+j*st)+1024 ; if(s<0) s=0 ; if(s>2047) s=2047 ;
		ss+= ((unsigned short)s % 32) * 8 ;
		*(c0+n)= (unsigned char)ss ; n++ ;
		ss= (unsigned short)s / 32 ;

		s= *(br+i+j*st)+512 ; if(s<0) s=0 ; if(s>1023) s=1023 ;
		ss+= ((unsigned short)s % 4) * 64 ;
		*(c0+n)= (unsigned char)ss ; n++ ;
		ss= (unsigned short)s / 4 ;

		*(c0+n)= (unsigned char)ss ; n++ ;

		*(bw+i+j*st)= 0 ;
		*(vg+i+j*st)= 0 ;
		*(br+i+j*st)= 0 ;
	}}
}

void us(){

	printf("
BitMapCompressor

usage: ec [input file1] [input file2] ...

    grade (image quality) value could be set in \"conf\" or \"conf.txt\" file

    grade value is number 1,2,3,...,1024
    the smaller, the lower quality and smaller file-size

    you can also set grade as follows
        f or fine    , equals to 32
        h or high    , equals to 16
        m or medium  , equals to 8
        l or low     , equals to 4

    if there is no conf files, grade value is set to medium

hit  Enter key to exit
") ;

getchar() ;
}