#include <math.h>

static unsigned long UL0= 16 ;
static unsigned long UL1,UL2,UL3,UL4,ULM ;

static unsigned char bb,bm ;
static int sc,rn ;
static unsigned long lo,hi ;
static int i0,i1,i2 ;

int pt(
	unsigned short *,
	unsigned short *,
	unsigned short *,
	unsigned char *,
	int,
	int *,
	unsigned char * ) ;

int ps(
	unsigned short *,
	unsigned char *,
	int,
	int *,
	unsigned char * ) ;

int gp(
	unsigned char *,
	unsigned short *,
	int ) ;

void ar(int, unsigned short, unsigned char *) ;
void pm(int, unsigned char *) ;
void pf(int, unsigned char *) ;

int pb(
	unsigned short *s0,
	unsigned short *s1,
	unsigned short *s2,
	unsigned char *c1,
	int *xs,
	int *ys,
	int lr,
	int *pn,
	unsigned char *pp )
{
	int i,ii ;

	UL1= 1 ; UL1<<= (UL0-2) ; UL2= UL1*2 ; UL3= UL1*3 ; UL4= UL1*4 ; ULM= UL4-1 ;

	sc=0 ; i0=0 ; i1=0 ; i2=0 ;
	for(i=lr;i>0;i--){
		ii= (lr-i)*36 ;
		pt(s0,s1,s2,c1,(xs[i-1]-xs[i])*(        ys[i]),pn,pp+ii+ 0) ;
		pt(s0,s1,s2,c1,(        xs[i])*(ys[i-1]-ys[i]),pn,pp+ii+12) ;
		pt(s0,s1,s2,c1,(xs[i-1]-xs[i])*(ys[i-1]-ys[i]),pn,pp+ii+24) ;
	}
	*pn= sc ;

	return 0 ;
}

int pt(
	unsigned short *s0,
	unsigned short *s1,
	unsigned short *s2,
	unsigned char *c1,
	int sz,
	int *pn,
	unsigned char *pp )
{
	i0+= ps(s0+i0,c1,sz,pn,pp+0) ;
	i1+= ps(s1+i1,c1,sz,pn,pp+4) ;
	i2+= ps(s2+i2,c1,sz,pn,pp+8) ;
}

int ps(
	unsigned short *s0,
	unsigned char *c1,
	int sz,
	int *pn,
	unsigned char *pp )
{
	int i,si,xx ;
	unsigned long ip,jp,kp,k0,k1,k2 ;
	unsigned short m0,m1 ;
	int n0,n1 ;
	int z,z0=0,z1=0 ;

	gp(pp,s0,sz) ;

	ip= (unsigned long)(*(pp+0)) ;
	if(!ip) return 0 ;

	ip= ip*ip*ip*ip ;

	k1= (unsigned long)(*(pp+1)) ;
	k2= (unsigned long)(*(pp+2)) ;
	k0= (256-k1)*(256-k2) ;
	k0= (ip >> 16)*k0 + (((ip & 65535)*k0 + 32768) >> 16) ;
	k2= (256-k1)*k2 ;
	k1*= 256 ;

	bb=0 ; bm=1 ; lo=0 ; hi=ULM ; rn=0 ;
	i=0 ; si=0 ; n0=0 ;

	jp= 32768*65535 ; jp= (jp << 1)-ip ;
	jp= 1 + (jp+32768+(ip >> 1))/(65536+ip) ;
	if(jp>65534) jp=65534 ;

	while(i<sz){
		m0= (*(s0+si) & 15) + 1 ;
		m1=  *(s0+si) >> 4 ;
		si++ ; i+= m0 ; n0+= m0 ;

		if(m1 || i==sz){
			n0-- ;
			if(n0){
				while(n0){
					ar(0, jp, c1) ;
					ip= (ip >> 16)*k2 + (((ip & 65535)*k2 + 32768) >> 16)
						+ k0 ;
					if(ip==0) ip=1 ;
					jp= 32768*65535 ; jp= (jp << 1)-ip ;
					jp= 1 + (jp+32768+(ip >> 1))/(65536+ip) ;
					if(jp>65534) jp=65534 ;
					n0-- ;
				}
			}
			if(m1){
				n1= (m1 & 2047) ;
				while(n1){
					ar(1, jp, c1) ;
					n1-- ;
				}
				ar(0, jp, c1) ;
				ar((m1>>11), 32768, c1) ;
				ip= (ip >> 16)*k2 + (((ip & 65535)*k2 + 32768) >> 16)
					+ ((unsigned long)m1&2047)*k1
					+ k0 ;
				if(ip==0) ip=1 ;
				jp= 32768*65535 ; jp= (jp << 1)-ip ;
				jp= 1 + (jp+32768+(ip >> 1))/(65536+ip) ;
				if(jp>65534) jp=65534 ;
			}else{
				ar(0, jp, c1) ;
			}
		}else{}
	}
	rn+= UL0 ;
	if(lo<UL2){ pm(0,c1) ; }else{ pm(1,c1) ; }
	if(bm>1){ *(c1+sc)= bb ; sc++ ; }

	return si ;
}

int gp(	unsigned char *pp,
	unsigned short *s0,
	int size)
{
	int i,ii,si,ip ;
	unsigned short m0,m1,mo,mm ;
	double sx,sy,sxx,sxy,sz,p ;
	double p0,p1,p2,pa,pb,pm ;

	sz= (double)size ;
	mo= (*(s0) & 15) ; if(mo){ mo=0 ; }else{ mo=(*(s0) >> 4) & 2047 ; }

	i=0 ; si=0 ; mm=0 ; sx=0 ; sy=0 ; sxx=0 ; sxy=0 ;
	while(i<size){
		m0= (*(s0+si) & 15) ;
		m1= (*(s0+si) >> 4) & 2047 ;
		si++ ; i+= m0+1 ;

		sy+= m1 ; sxx+= m1*m1 ; sxy+= mm*m1 ;

		if(m0){ mm=0 ; }else{ mm=m1 ; }
	}
	if(!sy){ *(pp+0)=0 ; return ; }
	p0= sy/sz ;
	sx= sy + p0 - m1 ;
	sxx= sxx + p0*p0 - m1*m1 ;
	sxy= sxy + p0*mo ;
	p1= (sz*sxy-sx*sy)/(sz*sxx-sx*sx) ;
	p2= 0.0 ;

	i=0 ; si=0 ; sx=0 ; sy=0 ; sxx=0 ; sxy=0 ;
	p= p0 ; pm= p ; pa= (1-p1)*p2 ; pb= (1-p1)*(1-p2)*p0 ;
	while(i<sz){
		m0= (*(s0+si) & 15) ;
		m1= (*(s0+si) >> 4) & 2047 ;
		si++ ; i+= m0+1 ;

		while(m0){
			p= pa*p + pb ;
			sx+= pm ; sy+= p ; sxx+= pm*pm ; sxy+= pm*p ;
			pm= 0 ;
			m0-- ;
		}

		p= p1*m1 + pa*p + pb ;
		sx+= pm ; sy+= p ; sxx+= pm*pm ; sxy+= pm*p ;
		pm= m1 ;
	}
	p1= (sz*sxy-sx*sy)/(sz*sxx-sx*sx) ;
	p2= 1.0 ;

	i=0 ; si=0 ; sx=0 ; sy=0 ; sxx=0 ; sxy=0 ;
	p= p0 ; pm= p ; pa= (1-p1)*p2 ; pb= (1-p1)*(1-p2)*p0 ;
	while(i<sz){
		m0= (*(s0+si) & 15) ;
		m1= (*(s0+si) >> 4) & 2047 ;
		si++ ; i+= m0+1 ;

		while(m0){
			p= pa*p + pb ;
			sx+= pm ; sy+= p ; sxx+= pm*pm ; sxy+= pm*p ;
			pm= p ;
			m0-- ;
		}

		p= p1*m1 + pa*p + pb ;
		sx+= pm ; sy+= p ; sxx+= pm*pm ; sxy+= pm*p ;
		pm= p ;
	}
	p2= (sz*sxy-sx*sy)/(sz*sxx-sx*sx) ;

	ii= (int)( pow(p0,0.25)*16+0.5 ) ;
	*(pp+0)=(unsigned char)ii ; if(ii<=1) *(pp+0)=1 ; if(ii>=255) *(pp+0)=255 ;

	ii= (int)( p1*256.0+0.5 ) ;
	*(pp+1)=(unsigned char)ii ; if(ii<=0) *(pp+1)=0 ; if(ii>=255) *(pp+1)=255 ;

	ii= (int)( p2*256.0+0.5 ) ;
	*(pp+2)=(unsigned char)ii ; if(ii<=0) *(pp+2)=0 ; if(ii>=255) *(pp+2)=255 ;
}

void ar(int b, unsigned short p, unsigned char *c1){

	if(b) lo= lo + (((hi-lo+1)*p+32768) >> 16) ;
	else  hi= lo + (((hi-lo+1)*p+32768) >> 16) - 1 ;

	while(1){
		if(hi < UL2) pm(0,c1) ;
		else if(lo >= UL2) pm(1,c1) ;
		else if(lo >= UL1 && hi < UL3){
			rn++ ;  lo -= UL1 ;  hi -= UL1 ;
		}else break ;

		lo <<= 1 ; if(lo >= UL4) lo-= UL4 ;
		hi <<= 1 ; if(hi >= UL4) hi-= UL4 ; hi++ ;
	}
}

void pm(int f, unsigned char *c1){
	pf(f,c1) ;
	while(rn){ pf(1-f,c1) ; rn-- ; }
}

void pf(int f, unsigned char *c1){
	if(f) bb |= bm ;

	if(bm!=128){ bm<<= 1 ; }
	else{ *(c1+sc)= bb ; bb= 0 ; bm= 1 ; sc++ ; }
}