#include <math.h>

void qc(short *, short *, short *, int, int, int, int, int, unsigned char *) ;

void qt(
	short *bw,
	short *vg,
	short *br,
	int *xsize,
	int *ysize,
	int gr,
	int lr,
	unsigned char *pp )
{
	int i,j,ii ;
	int xs,ys,st,ds,gg ;
	int gl[9] ;

	if(gr<1) gr=1 ; if(gr>65536) gr=65536 ;

	gl[0]= 65536 ;
	for(i=0;i<8;i++){
		gl[i+1]= gl[i]/2 ;
		if(gl[i+1]<gr) gl[i+1]= gr ;
	}

	st= xsize[0] ;

	qc(bw,vg,br,xsize[lr],ysize[lr],st,65536,65536,pp) ;

	for(i=lr;i>0;i--){
		ii= (lr-i)*36 ;

		xs= xsize[i-1]-xsize[i] ;
		ys= ysize[i] ;
		ds= xsize[i] ;
		gg= gl[i] ;
		qc(bw+ds,vg+ds,br+ds,xs,ys,st,gr,gg,pp+ii+ 0) ;

		xs= xsize[i] ;
		ys= ysize[i-1]-ysize[i] ;
		ds= ysize[i]*st ;
		gg= gl[i] ;
		qc(bw+ds,vg+ds,br+ds,xs,ys,st,gr,gg,pp+ii+12) ;

		xs= xsize[i-1]-xsize[i] ;
		ys= ysize[i-1]-ysize[i] ;
		ds= xsize[i]+ysize[i]*st ;
		gg= gl[i-1] ;
		qc(bw+ds,vg+ds,br+ds,xs,ys,st,gr,gg,pp+ii+24) ;
	}
}

void qc(
	short *bw,
	short *vg,
	short *br,
	int xs,
	int ys,
	int st,
	int gr,
	int gg,
	unsigned char *pp )
{
	int i,j,xy ;
	int ggh,grh,gg0,gg1,gg2 ;
	int l0,l1 ;
	int b0,b1,b2,c0,c1,c2 ;
	double f0,f1,f2,ff ;

	gg*= 20 ;
	ggh= (gg-1)/2 ;
	grh= (gr-1)/2 ;

	b0=0 ; b1=0 ; b2=0 ; c0=0 ; c1=0 ; c2=0 ;
	for(j=0;j<ys;j++){
	for(i=0;i<xs;i++){
		xy= i+st*j ;

		l0= (long)(*(bw+xy)) ;
		if(l0){
			if(l0>0){
				l1= (gr*l0+ggh)/gg ;
				if(l1){ b0+= l0 - (gg*l1+grh)/gr ; c0++ ; }
			}else{
				l1= -((gr*(-l0)+ggh)/gg) ;
				if(l1){ b0+= -l0 - ((gg*(-l1)+grh)/gr) ; c0++ ; }
			}
		}

		l0= (long)(*(vg+xy)) ;
		if(l0){
			if(l0>0){
				l1= (gr*l0+ggh)/gg ;
				if(l1){ b1+= l0 - (gg*l1+grh)/gr ; c1++ ; }
			}else{
				l1= -((gr*(-l0)+ggh)/gg) ;
				if(l1){ b1+= -l0 - ((gg*(-l1)+grh)/gr) ; c1++ ; }
			}
		}

		l0= (long)(*(br+xy)) ;
		if(l0){
			if(l0>0){
				l1= (gr*l0+ggh)/gg ;
				if(l1){ b2+= l0-(gg*l1+grh)/gr ; c2++ ; }
			}else{
				l1= -((gr*(-l0)+ggh)/gg) ;
				if(l1){ b2+= -l0 - ((gg*(-l1)+grh)/gr) ; c2++ ; }
			}
		}
	}}

	ff= (double)gg/20.0 ;
	ff= (16.0-log(ff)/log(2))/16.0 ;

	if(c0){ f0= (double)b0*gr/gg/c0+0.5 ; }else{ f0= 0.5 ; }
	if(f0<0) f0=0 ; if(f0>1) f0=1 ;
	gg0= (int)((0.5+(f0-0.5)*ff)*gg+0.5) ;

	if(c1){ f1= (double)b1*gr/gg/c1+0.5 ; }else{ f1= 0.5 ; }
	if(f1<0) f1=0 ; if(f1>1) f1=1 ;
	gg1= (int)((0.5+(f1-0.5)*ff)*gg+0.5) ;

	if(c2){ f2= (double)b2*gr/gg/c2+0.5 ; }else{ f2= 0.5 ; }
	if(f2<0) f2=0 ; if(f2>1) f2=1 ;
	gg2= (int)((0.5+(f2-0.5)*ff)*gg+0.5) ;

	b0=0 ; b1=0 ; b2=0 ; c0=0 ; c1=0 ; c2=0 ;
	for(j=0;j<ys;j++){
	for(i=0;i<xs;i++){
		xy= i+st*j ;

		l0= (long)(*(bw+xy)) ;
		if(l0){
			if(l0>0){
				l1= (gr*l0+gg0)/gg ; if(l1<0) l1=0 ;
				if(l1){ b0+= l0 - (gg*l1+grh)/gr ; c0++ ; }
			}else{
				l1= -((gr*(-l0)+gg0)/gg) ; if(l1>0) l1=0 ;
				if(l1){ b0+= -l0 - ((gg*(-l1)+grh)/gr) ; c0++ ; }
			}
		}else{
			l1= 0 ;
		}
		*(bw+xy)= (short)l1 ;

		l0= (long)(*(vg+xy)) ;
		if(l0){
			if(l0>0){
				l1= (gr*l0+gg1)/gg ; if(l1<0) l1=0 ;
				if(l1){ b1+= l0 - (gg*l1+grh)/gr ; c1++ ; }
			}else{
				l1= -((gr*(-l0)+gg1)/gg) ; if(l1>0) l1=0 ;
				if(l1){ b1+= -l0 - ((gg*(-l1)+grh)/gr) ; c1++ ; }
			}
		}else{
			l1= 0 ;
		}
		*(vg+xy)= (short)l1 ;

		l0= (long)(*(br+xy)) ;
		if(l0){
			if(l0>0){
				l1= (gr*l0+gg2)/gg ; if(l1<0) l1=0 ;
				if(l1){ b2+= l0-(gg*l1+grh)/gr ; c2++ ; }
			}else{
				l1= -((gr*(-l0)+gg2)/gg) ; if(l1>0) l1=0 ;
				if(l1){ b2+= -l0 - ((gg*(-l1)+grh)/gr) ; c2++ ; }
			}
		}else{
			l1= 0 ;
		}
		*(br+xy)= (short)l1 ;
	}}

	if(c0){ f0= b0*256.0*gr/gg/c0+128.5 ; b0= (int)f0 ; }
	if(b0<0) b0=0 ; if(b0>255) b0=255 ;

	if(c1){ f1= b1*256.0*gr/gg/c1+128.5 ; b1= (int)f1 ; }
	if(b1<0) b1=0 ; if(b1>255) b1=255 ;

	if(c2){ f2= b2*256.0*gr/gg/c2+128.5 ; b2= (int)f2 ; }
	if(b2<0) b2=0 ; if(b2>255) b2=255 ;

	*(pp+0+3)= (unsigned char)b0 ;
	*(pp+4+3)= (unsigned char)b1 ;
	*(pp+8+3)= (unsigned char)b2 ;
}